diff -BbruN freeswan-1.91.orig/pluto/xmap_ldap.h freeswan-1.91/pluto/xmap_ldap.h
--- freeswan-1.91.orig/pluto/xmap_ldap.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap_ldap.h	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,49 @@
+#ifndef XMAP_LDAP_H
+#define XMAP_LDAP_H
+
+#ifdef HAVE_LDAP
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+
+#include <lber.h>
+#include <ldap.h>
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct _flist_st {
+  char *index;
+  int type;
+  char *filter;
+} flist;
+
+#define MAXFLIST 10
+
+typedef struct _alist_st {
+  char *index;
+  int type;
+  char **attrs;
+} alist;
+
+typedef struct xmap_ldap_st {
+  char *ldapsource;
+  char *ldap_host;
+  int ldap_port;
+  char *ldap_base;
+  int ldap_timeout;
+  char *ldap_bindDN;
+  char *ldap_bindPW;
+  flist ldap_filter[MAXFLIST];
+  alist ldap_attrs[MAXFLIST];
+
+  LDAP *ld;
+
+  XMAP_METHOD *meth;
+} XMAP_LDAP;
+
+XMAP_METHOD *XMAP_METHOD_ldap( void );
+
+#endif /* HAVE_LDAP */
+
+#endif /* XMAP_LDAP_H */
diff -BbruN freeswan-1.91.orig/utils/Makefile freeswan-1.91/utils/Makefile
--- freeswan-1.91.orig/utils/Makefile	Thu Jun 14 09:20:14 2001
+++ freeswan-1.91/utils/Makefile	Mon Jul  2 21:49:48 2001
@@ -11,22 +11,30 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: Makefile,v 1.85 2001/06/14 13:20:14 henry Exp $
+# RCSID $Id: Makefile,v 1.74 2001/02/06 18:11:41 henry Exp $
 
 # pathnames, subject to overrides from main Makefile
 PUBDIR=/usr/local/sbin
 PRIVDIR=/usr/local/lib/ipsec
 REALPRIVDIR=/usr/local/lib/ipsec
+FINALPRIVDIR=/usr/local/lib/ipsec
 RCDIR=/etc/rc.d/init.d
 REALRCDIR=/etc/rc.d/init.d
 CONFDIR=/etc
-MANTREE=/usr/local/man
+MANTREE=/usr/man
 
 FMANDIR=$(MANTREE)/man5
 CMANDIR=$(MANTREE)/man8
 PUBS=ipsec
-BINS=ranbits rsasigkey
+
+ifeq "$(USEOPENSSL)" "1"
+SCRIPTS=barf manual auto look showdefaults showhostkey rehashcertdir rsakeygen updown.firewall
+BINS=ranbits rsasigkey fswcert
+else
 SCRIPTS=barf manual auto look showdefaults showhostkey
+BINS=ranbits rsasigkey
+endif
+
 INTERNALS=_include _confread _keycensor _secretcensor _updown \
 	_realsetup _startklips _plutorun _plutoload
 PRIVS=$(PUBS) $(SCRIPTS) $(INTERNALS) $(BINS)
@@ -49,6 +57,10 @@
 
 all:	$(PUBS) $(PRIVS) $(GENDFILES) $(LOCALS)
 
+fswcert: fswcert-0.4/fswcert.c
+	cd fswcert-0.4; $(MAKE)
+	cp fswcert-0.4/fswcert .
+
 ranbits:	ranbits.o
 	$(CC) $(CFLAGS) ranbits.o $(LIB) -o $@
 
@@ -93,43 +105,46 @@
 	./randomize conf.proto | egrep -v RCSI >$@
 
 install:	$(PUBS) $(PRIVS) $(MANS) $(GENDFILES)
-	mkdir -p $(PUBDIR) $(PRIVDIR) $(FMANDIR) $(CMANDIR) $(CONFDIR)
-	$(INSTALL) $(PUBS) $(PUBDIR)
-	$(INSTALL) $(PRIVS) $(PRIVDIR)
-	$(INSTALL) $(PUB) ipsec.conf.5 $(FMANDIR)
-	$(INSTALL) $(PUB) $(PLAIN_MANS) $(CMANDIR)
+	mkdir -p $(PREFIX)/$(PUBDIR) $(PREFIX)/$(PRIVDIR) 
+	mkdir -p $(PREFIX)/$(FMANDIR) $(PREFIX)/$(CMANDIR) 
+	mkdir -p $(PREFIX)/$(CONFDIR)
+	$(INSTALL) $(PUBS) $(PREFIX)/$(PUBDIR)
+	$(INSTALL) $(PRIVS) $(PREFIX)/$(PRIVDIR)
+	$(INSTALL) $(PUB) ipsec.conf.5 $(PREFIX)/$(FMANDIR)
+	$(INSTALL) $(PUB) $(PLAIN_MANS) $(PREFIX)/$(CMANDIR)
 	for f in $(IPSEC_CMANS) ; \
 	do \
-		$(INSTALL) $(PUB) $$f $(CMANDIR)/ipsec_$$f || exit 1 ; \
-		./manlink $(CMANDIR) ipsec_$$f ; \
+		$(INSTALL) $(PUB) $$f $(PREFIX)/$(CMANDIR)/ipsec_$$f || exit 1 ; \
+		./manlink $(PREFIX)/$(CMANDIR) ipsec_$$f ; \
 	done
-	test -f $(CONFDIR)/ipsec.secrets || \
-		$(INSTALL) $(PRIV) secrets.eg $(CONFDIR)/ipsec.secrets
-	test -f $(CONFDIR)/ipsec.conf || \
-		$(INSTALL) $(PUB) conf.eg $(CONFDIR)/ipsec.conf
+	test -d $(PREFIX)/$(CONFDIR) || $(INSTALL) -d $(PREFIX)/$(CONFDIR)
+	test -f $(PREFIX)/$(CONFDIR)/ipsec.secrets || \
+		$(INSTALL) $(PRIV) secrets.eg $(PREFIX)/$(CONFDIR)/ipsec.secrets
+	test -f $(PREFIX)/$(CONFDIR)/ipsec.conf || \
+		$(INSTALL) $(PUB) conf.eg $(PREFIX)/$(CONFDIR)/ipsec.conf
 	# main copy must go in RCDIR, PRIVDIR may not be mounted at boot time
-	mkdir -p $(RCDIR)
-	$(INSTALL) setup $(RCDIR)/ipsec
-	rm -f $(PRIVDIR)/setup
-	ln -s $(REALRCDIR)/ipsec $(PRIVDIR)/setup
-	PATH=/sbin:/usr/sbin:$$PATH ; export PATH ; \
-	if test " $(DESTDIR)" != " " ; \
-	then : do nothing ; \
-	elif which chkconfig >/dev/null 2>&1 ; \
+	test -d $(PREFIX)/$(RCDIR) || mkdir -p $(PREFIX)/$(RCDIR)
+	$(INSTALL) setup $(PREFIX)/$(RCDIR)/ipsec
+	rm -f $(PREFIX)/$(PRIVDIR)/setup
+	ln -s $(PREFIX)/$(REALRCDIR)/ipsec $(PREFIX)/$(PRIVDIR)/setup
+	# Only turn on the service if doing default install
+	if [ $(PREFIX) = '/' ] ; then \
+		if which chkconfig >/dev/null 2>&1 ; \
 	then chkconfig --add ipsec ; \
 	else $(MAKE) setup4 ; \
+		fi ; \
 	fi
 
+
 setup4:	$(RCDIR)/ipsec
-	# fallback rc install -- on in run states 2345, off in 016, with
-	# priorities matching those in setup's chkconfig line
-	-cd $(RCDIR)/../rc0.d ; ln -s ../init.d/ipsec K68ipsec
-	-cd $(RCDIR)/../rc1.d ; ln -s ../init.d/ipsec K68ipsec
-	-cd $(RCDIR)/../rc2.d ; ln -s ../init.d/ipsec S47ipsec
-	-cd $(RCDIR)/../rc3.d ; ln -s ../init.d/ipsec S47ipsec
-	-cd $(RCDIR)/../rc4.d ; ln -s ../init.d/ipsec S47ipsec
-	-cd $(RCDIR)/../rc5.d ; ln -s ../init.d/ipsec S47ipsec
-	-cd $(RCDIR)/../rc6.d ; ln -s ../init.d/ipsec K68ipsec
+	# fallback rc install -- on in run states 2345, off in 016
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc0.d ; ln -s ../init.d/ipsec K68ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc1.d ; ln -s ../init.d/ipsec K68ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc2.d ; ln -s ../init.d/ipsec S47ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc3.d ; ln -s ../init.d/ipsec S47ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc4.d ; ln -s ../init.d/ipsec S47ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc5.d ; ln -s ../init.d/ipsec S47ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc6.d ; ln -s ../init.d/ipsec K68ipsec
 
 clean:
 	rm -f *.o $(BINS) $(GENDFILES) $(GENDSCRIPTS) $(LOCALS)
diff -BbruN freeswan-1.91.orig/utils/_confread freeswan-1.91/utils/_confread
--- freeswan-1.91.orig/utils/_confread	Wed Jun 13 16:09:19 2001
+++ freeswan-1.91/utils/_confread	Mon Jul  2 21:38:15 2001
@@ -1,6 +1,6 @@
 #!/bin/sh
 # configuration-file reader utility
-# Copyright (C) 1999, 2000, 2001  Henry Spencer.
+# Copyright (C) 1999, 2000  Henry Spencer.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _confread,v 1.41 2001/06/13 20:09:19 henry Exp $
+# RCSID $Id: _confread,v 1.39 2001/06/01 15:49:13 henry Exp $
 #
 # Extract configuration info from /etc/ipsec.conf, repackage as assignments
 # to shell variables or tab-delimited fields.  Success or failure is reported
@@ -47,7 +47,6 @@
 fieldfmt=yes
 prefix=
 search=
-export=0
 me="ipsec _confread"
 
 for dummy
@@ -120,10 +119,11 @@
 			fail("invalid section name " bq na[i] eq)
 	}
 
-	good = "also type auto authby"
+	good = "also type auto authby force_encrypt_cypher"
 	left = " left leftsubnet leftnexthop leftfirewall leftupdown"
 	akey = " keyexchange auth pfs keylife rekeymargin rekeyfuzz compress"
 	obs = " lifetime rekeystart rekeytries"
+	cert = " certfile keyfile peerfile certopts certpath"
 	akey = akey " keyingtries ikelifetime" obs
 	mkey = " spibase spi esp espenckey espauthkey espreplay_window"
 	left = left " leftespenckey leftespauthkey leftahkey"
@@ -131,7 +131,7 @@
 	mkey = mkey " ah ahkey ahreplay_window"
 	right = left
 	gsub(/left/, "right", right)
-	n = split(good left right akey mkey, g)
+	n = split(good left right akey mkey cert, g)
 	for (i = 1; i <= n; i++)
 		goodnames["conn:" g[i]] = 1
 
@@ -231,7 +232,7 @@
 	# referencing is transitive:  xyz->from->to
 	if (from in refsto) {
 		listnum = split(refsto[from], reflist, ";")
-		for (i = 1; i <= listnum; i++)
+		for (i=1; i <= listnum; i++)
 			chainref(reflist[i], to)
 	}
 	addref(from, to)
@@ -337,7 +338,7 @@
 			searchfound(sectionname)
 	} else {
 		# rather a kludge, but must check this somewhere
-		if (search == "auto" && rest !~ /^(add|route|start|ignore)$/)
+		if (search == "auto" && rest !~ /^(add|route|start|ignore|background)$/)
 			fail("illegal auto value " bq rest eq)
 	}
 	next
diff -BbruN freeswan-1.91.orig/utils/auto freeswan-1.91/utils/auto
--- freeswan-1.91.orig/utils/auto	Fri Jun  1 11:49:13 2001
+++ freeswan-1.91/utils/auto	Mon Jun  4 10:44:49 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: auto,v 1.61 2001/06/01 15:49:13 henry Exp $
+# RCSID $Id: auto,v 1.59 2001/05/04 05:31:50 henry Exp $
 
 me='ipsec auto'
 usage="Usage:
@@ -323,8 +323,10 @@
 			s["rightupdown"] = s["rightupdown"] " ipfwadm"
 
 		default("authby", "secret")
+		authbyfound = "0"
 		authtype = "--psk"
 		if (s["authby"] == "rsasig") {
+			authbyfound = "1"
 			authtype = "--rsasig"
 			need("leftrsasigkey")
 			need("rightrsasigkey")
@@ -332,8 +334,45 @@
 				fail("ID \"" id("left") "\" cannot have RSA key")
 			if (id("right") == "%any")
 				fail("ID \"" id("right") "\" cannot have RSA key")
-		} else if (s["authby"] != "secret")
+		}
+
+
+		if (s["authby"] == "cert") {
+			authbyfound = "1"
+			default("certfile", "")
+			default("certopts", "send")
+			default("keyfile", "")
+			default("certpath", "")
+			authtype = "--openssl"
+			need("certfile")
+			need("certopts")
+			need("keyfile")
+			need("certpath")
+		}
+
+		if (s["authby"] != "secret") {
+		  if (s["authby"] != "psk") {
+			if (authbyfound != "1") {
 			fail("unknown authby value \"" s["authby"] "\"")
+			}
+		  }
+		}
+
+		default("force_encrypt_cypher", "")
+		if ("force_encrypt_cypher" in s) {
+			if (s["force_encrypt_cypher"] == "des") {
+				force_encrypt_cypher = "des"
+			}
+			if (s["force_encrypt_cypher"] == "DES") {
+				force_encrypt_cypher = "des"
+			}
+			if (s["force_encrypt_cypher"] == "3des") {
+				force_encrypt_cypher = "3des"
+			}
+			if (s["force_encrypt_cypher"] == "3DES") {
+				force_encrypt_cypher = "3des"
+			}
+		}
 
 		settings = "--encrypt"
 		if (s["type"] != "transport")
@@ -368,6 +407,17 @@
 		if ("rekeyfuzz" in s)
 			fuzz = "--rekeyfuzz " s["rekeyfuzz"]
 
+		if (authtype == "--openssl") {
+			if ("certfile" in s)
+				certfile = "--certfile " s["certfile"]
+			if ("certopts" in s)
+				certopts = "--certopts " s["certopts"]
+			if ("keyfile" in s)
+				keyfile = "--keyfile " s["keyfile"]
+			if ("certpath" in s)
+				certpath = "--certpath " s["certpath"]
+		}
+
 		print "ipsec whack --name", name, settings, "\\"
 		print "\t--host", s["left"], lc,
 				"--nexthop", s["leftnexthop"], lud, lid, "\\"
@@ -375,8 +425,23 @@
 				"--nexthop", s["rightnexthop"], rud, rid, "\\"
 		print "\t--ipseclifetime", s["keylife"],
 			"--rekeywindow", s["rekeymargin"], "\\"
+		if (authtype == "--openssl") {
+			if (certfile != "--certfile ")
+				print certfile, "\\"
+			if (certopts != "--certopts ")
+				print certopts, "\\"
+			if (keyfile != "--keyfile ")
+				print keyfile, "\\"
+			if (certpath != "--certpath ")
+				print certpath, "\\"
+		}
+
+		if (force_encrypt_cypher != "") {
+			print "\t--force_encrypt_cypher", s["force_encrypt_cypher"], "\\"
+		}
+
 		print "\t--keyingtries", s["keyingtries"], fuzz
-		if (authtype != "--psk") {
+		if (authtype == "--rsasig") {
 			whackkey("left")
 			whackkey("right")
 		}
diff -BbruN freeswan-1.91.orig/utils/barf freeswan-1.91/utils/barf
--- freeswan-1.91.orig/utils/barf	Fri Jun 15 12:18:22 2001
+++ freeswan-1.91/utils/barf	Mon Jun  4 10:45:44 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: barf,v 1.50 2001/06/15 16:18:22 henry Exp $
+# RCSID $Id: barf,v 1.47 2001/06/01 15:49:13 henry Exp $
 
 KERNSRC=${KERNSRC-/usr/src/linux}
 LOGS=${LOGS-/var/log}
@@ -75,10 +75,6 @@
 hostname ; date
 set -x
 _________________________
-ipsec --version
-_________________________
-cat /proc/version
-_________________________
 cat /proc/net/ipsec_eroute
 _________________________
 cat /proc/net/ipsec_spi
@@ -91,14 +87,14 @@
 _________________________
 cat /proc/net/pf_key
 _________________________
-( cd /proc/net ; egrep '^' pf_key_* )
-_________________________
 ( cd /proc/sys/net/ipsec ; egrep '^' * )
 _________________________
 ipsec auto --status
 _________________________
 ifconfig -a
 _________________________
+ipsec --version
+_________________________
 ipsec --directory
 _________________________
 hostname --fqdn
@@ -128,6 +124,8 @@
 _________________________
 uname -a
 _________________________
+cat /proc/version
+_________________________
 if test -r /etc/redhat-release
 then
 	cat /etc/redhat-release
@@ -137,15 +135,15 @@
 _________________________
 ipchains -L -v -n
 _________________________
-ipfwadm -F -l -n -e
+ipfwadm -F -l -n
 _________________________
-ipfwadm -I -l -n -e
+ipfwadm -I -l -n
 _________________________
-ipfwadm -O -l -n -e
+ipfwadm -O -l -n
 _________________________
 ipchains -M -L -v -n
 _________________________
-ipfwadm -M -l -n -e
+ipfwadm -M -l -n
 _________________________
 cat /proc/modules
 _________________________
diff -BbruN freeswan-1.91.orig/utils/fswcert-0.4/Makefile freeswan-1.91/utils/fswcert-0.4/Makefile
--- freeswan-1.91.orig/utils/fswcert-0.4/Makefile	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/fswcert-0.4/Makefile	Wed May 16 10:57:20 2001
@@ -0,0 +1,26 @@
+###################################################
+# Adjust SSLDIR before make ...
+SSLDIR=/usr/ssl
+
+# Adjust IPSECDIR before make install ...
+IPSECDIR=/usr/lib/ipsec
+###################################################
+
+VERSION = 0.4
+
+CFLAGS = -g -Wall -O2 -DVERSION=\"$(VERSION)\" -I$(SSLDIR)/include -I$(OPENSSLROOT)/include
+LDFLAGS = -g -L$(SSLDIR)/lib -L$(OPENSSLROOT)/lib
+LDLIBS = -lcrypto
+
+DISTFILES=Makefile README fswcert.c _confread.patch
+
+all : fswcert
+
+fswcert : fswcert.o
+	$(CC) $(LDFLAGS) -o fswcert fswcert.o $(LDLIBS)
+
+fswcert.o: fswcert.c
+	$(CC) $(CFLAGS) -c fswcert.c
+
+clean :
+	rm -f fswcert fswcert.o
diff -BbruN freeswan-1.91.orig/utils/fswcert-0.4/README freeswan-1.91/utils/fswcert-0.4/README
--- freeswan-1.91.orig/utils/fswcert-0.4/README	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/fswcert-0.4/README	Wed May 16 10:57:20 2001
@@ -0,0 +1,94 @@
+fswcert Utility
+===============
+
+
+This replaces the grabkey and grabsubject utilities from the
+FreeS/WAN X.509 patch, and supports the new configuration
+options leftcert=... and rightcert=...
+
+Dependencies:
+  fswcert requires the openssl 0.9.5a package.
+
+Bugs:
+  Due to openssl, the fswcert binary is HUGE.
+
+
+These are the options supported:
+--------------------------------
+
+-c --certificate	print certificate data
+
+	Prints the certificate data needed for FreeS/WAN's
+	ipsec.conf. Input can be from an X.509 file in PEM
+	or DER format, or from a PKCS12 (*.p12) file.
+
+-k --key	print private RSA key data
+
+	Prints the private key data needed for FreeS/WAN's
+	ipsec.secrets. Input can be from an RSA private key
+	file, or from a PKCS12 (*.p12) file.
+
+-l --left	left-side parameters for ipsec.conf
+
+	Prefix certificate data with `left'
+
+-r --right	right-side parameters for ipsec.conf
+
+	Prefix certificate data with `left'
+
+--type=[x509|rsa|pkcs12]	select input file type
+
+	Select input file type. Defaults to x509.
+
+--format=[PEM|DER]	select input file format
+
+	Select input file format. Defaults to PEM.
+
+-C --directory=dir	change into dir first
+
+	Change into dir at startup. (Files are then
+	read relative to this directory).
+
+-q --quiet	single line error messages to stdout
+
+	This is a hack to better integrate with _confread.
+	Don't use manually.
+
+-d --der-output		outputs DN in DER binary format
+
+	This is also a hack. Useful to give the CA the DN in DER
+	so that it can insert the 'subject' search field in its
+	LDAP tables. 
+
+-v --version	returns version of fswcert
+
+Either --key or --certificate is required. It makes no sense to
+specify both --left and --right; the last option wins.
+
+
+To use X.509 PEM-encoded certificates with FreeS/WAN directly, do this:
+-----------------------------------------------------------------------
+
+- Adjust the IPSECDIR and SSLDIR in Makefile
+
+- Build fswcert with `make'
+
+- Install fswcert with `make install'
+
+- Patch FreeS/WAN's _confread with the patch provided
+
+- Put all the certificates you want to use with FreeS/WAN
+  in the /etc/ipsec.d/ directory
+
+
+Then you can use these new options in ipsec.conf and includes:
+--------------------------------------------------------------
+
+leftcert=filename.pem
+	Reads the identity and public key from filename.pem
+	(Replaces both leftid=@~... and leftrsasigkex=0x...)
+
+rightcert=filename.pem
+	Reads the identity and public key from filename.pem
+	(Replaces both rightid=@~... and rightrsasigkex=0x...)
+
diff -BbruN freeswan-1.91.orig/utils/fswcert-0.4/fswcert.c freeswan-1.91/utils/fswcert-0.4/fswcert.c
--- freeswan-1.91.orig/utils/fswcert-0.4/fswcert.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/fswcert-0.4/fswcert.c	Wed May 16 11:20:34 2001
@@ -0,0 +1,550 @@
+/* Certificate and Private Key Format Conversions for FreeS/WAN
+ *
+ * Copyright (C) 2000 Andreas Gruenbacher, <a.gruenbacher@computer.org>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+#include <stdio.h>
+#include <stdarg.h>
+#include <string.h>
+#include <unistd.h>
+
+#define _GNU_SOURCE
+#include <getopt.h>
+
+#include <termio.h>
+
+#include <openssl/crypto.h>
+#include <openssl/buffer.h>
+#include <openssl/bio.h>
+#include <openssl/err.h>
+#include <openssl/pkcs12.h>
+#include <openssl/pem.h>
+#include <openssl/rsa.h>
+
+struct option long_options[] = {
+	{"certificate",   0, 0, 'c'},
+	{"key",           0, 0, 'k'},
+	{"left",          0, 0, 'l'},
+	{"right",         0, 0, 'r'},
+	{"type",          1, 0,  1 },
+	{"format",        1, 0,  2 },
+	{"quiet",         0, 0, 'q'},
+	{"der-output",    0, 0, 'd'},
+	{"directory",     1, 0, 'C'},
+	{"version",       0, 0, 'v'},
+	{"help",          0, 0, 'h'},
+	{NULL,            0, 0,  0 }
+};
+
+int prompt_for_passwords = 0;
+const char *peer_prefix = NULL;
+int opt_quiet = 0;
+int der_output = 0;
+int der_binary = 0;
+const char *input_file = NULL;
+
+#define DUMP_CERTIFICATE	1
+#define DUMP_KEY		2
+int opt_what = 0;
+
+BIO *bio_err = NULL;
+
+enum input_file_type { IN_PKCS12 = 1, IN_X509 = 2, IN_RSA = 3 };
+enum input_format { FORMAT_ASN1 = 1, FORMAT_PEM = 3 };
+
+void print_errors(int ssl, const char *fmt, ...)
+{
+	if (fmt) {
+		va_list args;
+	
+		va_start(args, fmt);
+		if (input_file)
+			fprintf(stderr, "%s: ", input_file);
+		fprintf(stderr, "Error ");
+		vfprintf(stderr, fmt, args);
+		fprintf(stderr, "\n");
+		va_end(args);
+	}
+	if (ssl && !opt_quiet)
+		ERR_print_errors(bio_err);
+}
+
+const char *read_password(void)
+{
+	static char password[1024];
+	struct termio saved, no_echo;
+
+	printf("Password: ");
+
+	(void) ioctl(0, TCGETA, &saved);
+	no_echo = saved;
+	no_echo.c_lflag &= ~ECHO;
+	(void) ioctl(0, TCSETA, &no_echo);
+	fgets(password, sizeof(password), stdin);
+	(void) ioctl(0, TCSETA, &saved);
+	puts("");
+
+	if (strchr(password, '\n'))
+		*strchr(password, '\n') = '\0';
+	return password;
+}
+
+void BN_print_0(BIGNUM *num)
+{
+	int bits = BN_num_bits(num);
+
+	if ((bits-1) % 8 < 3)
+		putchar('0');
+	BN_print_fp(stdout, num);
+}
+
+#define print(what, num) do { \
+	printf("\t%s: 0x", what); \
+	BN_print_0(num); \
+	putchar('\n'); \
+	} while(0)
+
+int dump_rsa_private_key(RSA *rsa)
+{
+	if (rsa->d == NULL) {
+		print_errors(0, "no private exponent");
+		return 1;
+	}
+	if (opt_what & DUMP_KEY) {
+		print("Modulus", rsa->n);
+		print("PublicExponent", rsa->e);
+		print("PrivateExponent", rsa->d);
+		print("Prime1", rsa->p);
+		print("Prime2", rsa->q);
+		print("Exponent1", rsa->dmp1);
+		print("Exponent2", rsa->dmq1);
+		print("Coefficient", rsa->iqmp);
+	}
+	return 0;
+}
+
+#undef print
+
+int dump_x509_certificate(X509 *x509)
+{
+	BUF_MEM *subject;
+	EVP_PKEY *pkey;
+	RSA *rsa;
+	int i, error = 0;
+	char derbuf[256];
+	
+	if (!x509->cert_info || !x509->cert_info->subject ||
+            !x509->cert_info->subject->bytes) {
+		fprintf(stderr, "Certificate contains no subject\n");
+		return 1;
+	}
+	subject = &x509->cert_info->subject->bytes[0];
+
+	if (opt_what & DUMP_CERTIFICATE) {
+		if (!der_output) {
+			printf("\t%sid=@~", peer_prefix);
+			for (i = 0; i < subject->length; i++)
+				printf("%02X", (unsigned char)subject->data[i]);
+			printf("\n");
+		} else if (der_output) {
+			int derlen;
+			unsigned char *derbytes, *derout;
+
+			derlen=i2d_X509_NAME(x509->cert_info->subject, NULL);
+			derbytes=malloc(derlen);
+			derout=(unsigned char *)derbytes;
+
+			derlen=i2d_X509_NAME(X509_get_subject_name(x509), &derout);
+			derout=(unsigned char *)derbytes;
+
+			if (der_binary) {
+				for (i = 0; i < derlen; i++)
+					printf("%c", derout[i]);
+			} else {
+				X509_NAME_oneline(x509->cert_info->subject,
+					derbuf, 256);
+				printf("\t#%s DN: %s\n", peer_prefix, derbuf);
+				printf("\t%sid=@~", peer_prefix);
+				for (i = 0; i < derlen; i++)
+					printf("%02X", (unsigned char)derout[i]);
+				printf("\n");
+
+#if 0
+{ /* DEBUGGING ON */
+  X509_NAME *xn = X509_NAME_new();
+  char dnout[256];
+  if (xn == NULL) {
+    printf("\t#Unable to malloc X509_NAME *xn");
+  }
+
+  printf("\t#derlen = %d\n", derlen);
+  printf("\t#certlen = %d\n", certlen);
+
+  /* X509_NAME * d2i_X509_NAME(X509_NAME **a,unsigned char **pp,long length); 
+   */
+  xn = d2i_X509_NAME(&xn, &(derout), (long)derlen);
+
+  if (xn != NULL) {
+    X509_NAME_oneline(xn,dnout,256);
+    printf("\t#DNtest == %s\n", dnout);
+  } else {
+    printf("\t#Invalid DER string\n");
+  }
+} /* DEBUGGING OFF */
+#endif
+
+			}
+
+			free(derbytes);
+		}
+	}
+
+	pkey = X509_get_pubkey(x509);
+	if (pkey == NULL) {
+		print_errors(1, "getting public key");
+		return 1;
+	}
+	if (pkey->type != EVP_PKEY_RSA) {
+		print_errors(0, "not an RSA public key");
+		error = 1;
+		goto cleanup;
+	}
+	rsa = pkey->pkey.rsa;
+	
+#if 0
+	if (opt_what & DUMP_CERTIFICATE) {
+		int bytes = BN_num_bytes(rsa->e);
+		printf("\t%srsasigkey=0x%02X", peer_prefix, bytes);
+		BN_print_0(rsa->e);
+		BN_print_0(rsa->n);
+		putchar('\n');
+	}
+#endif
+
+cleanup:
+	EVP_PKEY_free(pkey);
+	return 0;
+}
+
+int read_pkcs12_safebag(PKCS12_SAFEBAG *bag, const char *password)
+{
+	PKCS8_PRIV_KEY_INFO *p8;
+	EVP_PKEY *pkey;
+	X509 *x509;
+	RSA *rsa;
+	int error = 0;
+	
+	switch (M_PKCS12_bag_type(bag)) {
+		case NID_keyBag:
+			p8 = bag->value.keybag;
+			pkey = EVP_PKCS82PKEY(p8);
+			if (!pkey) {
+				print_errors(1, "grabbing private key");
+				return 1;
+			}
+			rsa = EVP_PKEY_get1_RSA(pkey);
+			EVP_PKEY_free(pkey);
+			if (!rsa) {
+				print_errors(1, "getting RSA key");
+				return 1;
+			}
+			error = dump_rsa_private_key(rsa);
+			RSA_free(rsa);
+			break;
+
+		case NID_pkcs8ShroudedKeyBag:
+			p8 = M_PKCS12_decrypt_skey(bag, password, -1);
+			if (!p8) {
+				print_errors(1, "decrypting private key");
+				return 1;
+			}
+			pkey = EVP_PKCS82PKEY(p8);
+			PKCS8_PRIV_KEY_INFO_free(p8);
+			if (!pkey) {
+				print_errors(1, "grabbing private key");
+				return 1;
+			}
+			rsa = EVP_PKEY_get1_RSA(pkey);
+			EVP_PKEY_free(pkey);
+			if (!rsa) {
+				print_errors(1, "getting RSA private key");
+				return 1;
+			}
+			error = dump_rsa_private_key(rsa);
+			RSA_free(rsa);
+			break;
+
+		case NID_certBag:
+			if (M_PKCS12_cert_bag_type(bag) != NID_x509Certificate){
+				print_errors(0, "not an X.509 certificate");
+				return 1;
+			}
+			/* only dump the key's certificate */
+			if (!PKCS12_get_attr(bag, NID_localKeyID))
+				return 0;
+			x509 = M_PKCS12_certbag2x509(bag);
+			if (!x509) {
+				print_errors(1, "grabbing certificate");
+				return 1;
+			}
+			if (dump_x509_certificate(x509))
+				return 1;
+			X509_free(x509);
+			break;
+
+		default:
+			/* other bag entry */
+	}
+	return error;
+}
+
+int read_pkcs12_file(BIO *bio_in)
+{
+	const char *password = "\0";
+	PKCS12 *p12;
+	STACK /* _OF(PKCS7) */ *asafes = NULL;
+	PKCS7 *p7;
+	int i;
+
+	p12 = d2i_PKCS12_bio (bio_in, NULL);
+	if (!p12) {
+		print_errors(1, "reading PKCS12 file");
+		return 1;
+	}
+	if (!PKCS12_verify_mac(p12, password, 0)) {
+		if (prompt_for_passwords)
+			password = read_password();
+		if (!prompt_for_passwords ||
+		    !PKCS12_verify_mac(p12, password, -1)) {
+			print_errors(1, "verifying MAC: wrong password?");
+			return 1;
+		}
+	}
+
+	/* Unpack PKCS12 file */
+	asafes = M_PKCS12_unpack_authsafes (p12);
+	if (!asafes) {
+		print_errors(1, "unpacking PKCS12 file");
+		return 1;
+	}
+	for (i = 0; i < sk_num(asafes); i++) {
+		int bagnid, j;
+		STACK /* _OK(PKCS12) */ *bags;
+
+		p7 = (PKCS7 *) sk_value(asafes, i);
+		bagnid = OBJ_obj2nid(p7->type);
+		if (bagnid == NID_pkcs7_data)
+			bags = M_PKCS12_unpack_p7data(p7);
+		else if (bagnid == NID_pkcs7_encrypted)
+			bags = M_PKCS12_unpack_p7encdata(p7, password, -1);
+		else
+			continue;
+		if (!bags) {
+			print_errors(1, "unpacking PKCS12 file");
+			return 1;
+		}
+		for (j = 0; j < sk_num(bags); j++) {
+			PKCS12_SAFEBAG *bag =
+				(PKCS12_SAFEBAG *)sk_value(bags, j);
+			if (read_pkcs12_safebag(bag, password))
+				return 1;
+		}
+		sk_pop_free(bags, PKCS12_SAFEBAG_free);
+	}
+	sk_pop_free(asafes, PKCS7_free);
+	return 0;
+}
+
+int read_x509_file(BIO *bio_in, enum input_format input_format)
+{
+	X509 *x509 = NULL;
+	int error;
+
+	if (input_format == FORMAT_PEM)
+		x509 = PEM_read_bio_X509(bio_in, NULL, NULL, NULL);
+	else if (input_format == FORMAT_ASN1)
+		x509 = d2i_X509_bio(bio_in, NULL);
+	if (!x509) {
+		print_errors(1, "reading X509 certificate");
+		return 1;
+	}
+	error = dump_x509_certificate(x509);
+	X509_free(x509);
+
+	return error;
+}
+
+int read_rsa_file(BIO *bio_in, enum input_format input_format)
+{
+	RSA *rsa = NULL;
+	int error;
+
+	if (input_format == FORMAT_PEM)
+		rsa = PEM_read_bio_RSAPrivateKey(bio_in, NULL, NULL, NULL);
+	else if (input_format == FORMAT_ASN1)
+		rsa = d2i_RSAPrivateKey_bio(bio_in, NULL);
+	if (!rsa) {
+                print_errors(1, "reading RSA private key");
+                return 1;
+        }
+	error = dump_rsa_private_key(rsa);
+	RSA_free(rsa);
+	return error;
+}
+
+int main(int argc, char *argv[])
+{
+	enum input_file_type input_file_type = 0;
+	enum input_format input_format = 0;
+	int error = 0, opt;
+
+	prompt_for_passwords = isatty(0) && isatty(1);
+
+	while ((opt = getopt_long(argc, argv, "cklrqd:C:hv",
+	                          long_options, NULL)) != -1) {
+		switch(opt) {
+			case 1:  /* input file type */
+				if (!strcmp(optarg, "pkcs12"))
+					input_file_type = IN_PKCS12;
+				else if (!strcmp(optarg, "x509"))
+					input_file_type = IN_X509;
+				else if (!strcmp(optarg, "rsa"))
+					input_file_type = IN_RSA;
+				else
+					goto synopsis;
+				break;
+
+			case 2:  /* input format */
+				if (!strcmp(optarg, "PEM"))
+					input_format = FORMAT_PEM;
+				else if (!strcmp(optarg, "DER"))
+					input_format = FORMAT_ASN1;
+				else
+					goto synopsis;
+				break;
+
+			case 'c':  /* certificate */
+				opt_what |= DUMP_CERTIFICATE;
+				if (!input_file_type)
+					input_file_type = IN_X509;
+				break;
+
+			case 'k':  /* key */
+				opt_what |= DUMP_KEY;
+				if (!input_file_type)
+					input_file_type = IN_RSA;
+				break;
+
+			case 'l':  /* left */
+				if (!opt_what)
+					opt_what = DUMP_CERTIFICATE;
+				peer_prefix = "left";
+				break;
+
+			case 'r':  /* right */
+				if (!opt_what)
+					opt_what = DUMP_CERTIFICATE;
+				peer_prefix = "right";
+				break;
+
+			case 'C':  /* change directory */
+				if (chdir(optarg) && errno) {
+					perror(optarg);
+					error = 1;
+				}
+				break;
+
+			case 'v':  /* print version and exit */
+				printf("%s " VERSION "\n", argv[0]);
+				return 0;
+
+			case 'q':  /* quiet */
+				opt_quiet = 1;
+				break;
+
+			case 'd':  /* output in DER */
+				der_output = 1;
+				if (!strcmp(optarg, "a")) { 
+					/* ascii */
+					der_binary = 0;
+				} else if (!strcmp(optarg, "b")) {
+					der_binary = 1;
+				} else {
+					goto synopsis;
+				}
+				break;
+
+			default:
+				goto synopsis;
+		}
+	}
+	if (peer_prefix == NULL)
+		peer_prefix = "";
+
+	if (optind+1 != argc || !opt_what)
+		goto synopsis;
+
+	if (!input_file_type)
+		input_file_type = IN_X509;
+	if (!input_format)
+		input_format = FORMAT_PEM;
+
+	if (opt_quiet)
+		dup2(1,2);  /* stderr is stdout (awk hack) */
+
+	ERR_load_crypto_strings();
+	SSLeay_add_all_algorithms();
+	bio_err = BIO_new_fp (stderr, BIO_NOCLOSE);
+	
+	while (optind < argc) {
+		BIO *bio_in;
+
+		input_file = argv[optind];
+		bio_in = BIO_new_file(input_file, "rb");
+		if (!bio_in) {
+			perror(input_file);
+			error = 1;
+		} else {
+			if (input_file_type == IN_PKCS12)
+				error |= read_pkcs12_file(bio_in);
+			else if (input_file_type == IN_X509)
+				error |= read_x509_file(bio_in, input_format);
+			else if (input_file_type == IN_RSA)
+				error |= read_rsa_file(bio_in, input_format);
+			BIO_free(bio_in);
+		}
+		optind++;
+	}
+
+	BIO_free(bio_err);
+
+	return error;
+
+synopsis:
+	fprintf(stderr, "SYNOPSIS: %s --cert|--key [--left|--right] "
+	        "options file\n", argv[0]);
+	if (!opt_quiet) {
+		fprintf(stderr, "\t-c --cert\tprint certificate data\n"
+		        "\t-k --key\tprint private RSA key data\n"
+		        "\t-l --left\tleft-side parameters for ipsec.conf\n"
+		        "\t-r --right\tright-side parameters for ipsec.conf\n"
+		        "\t   --type=[x509|rsa|pkcs12]\tselect input file type\n"
+		        "\t   --format=[PEM|DER]\tselect input file format\n"
+		        "\t-C --directory=dir\tchange into dir first\n"
+		        "\t-d [ab]\tprints out the DER\n"
+			
+		        "\t-q --quiet\tsingle line error messages to stdout\n");
+	}
+	return error;
+}
+
diff -BbruN freeswan-1.91.orig/utils/rehashcertdir freeswan-1.91/utils/rehashcertdir
--- freeswan-1.91.orig/utils/rehashcertdir	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/rehashcertdir	Wed May 16 10:57:20 2001
@@ -0,0 +1,38 @@
+#!/bin/sh 
+if [ "$1" = "" ];
+then 
+  echo "Error: No directory to process."
+  echo "Usage: $0 <directory>"
+  echo
+  exit 1
+fi
+
+if [ ! -d $1 ];
+then
+  echo "Error: "$1" is not a directory."
+  echo "Usage: $0 <directory>"
+  echo
+  exit 2
+fi
+
+cd $1
+for ii in *.pem; do
+  if [ "`basename $ii`" = "crl.pem" ];
+  then
+    ln -fs $ii `openssl crl -noout -hash -in crl.pem`.crl.0
+  else
+    ln -fs $ii `openssl x509 -noout -hash -in $ii`.cert.0
+    perl -e "open(IN, \"openssl x509 -in $ii -noout -text \|\"); \
+      @IN = <IN>; \
+      foreach (@IN) { \
+        if (/IP Address:(\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3})/) { \
+          system(\"ln -sf $ii `dirname $ii`/ip-\$1.cert.0\"); \
+        } \
+        if (/DNS:([^, ]*).*$/) { \
+          system(\"ln -sf $ii `dirname $ii`/dns-\$1.cert.0\"); \
+        } \
+      };"
+  fi
+done
+
+
